/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "stdafx.h"
#include "api.h"
#include "api_private.h"
#include "task.h"
#include "drivers/xmpp/driver.h"
//------------------------------------------------------------------------------
using namespace WSW::Core;
//------------------------------------------------------------------------------
// TODO!!!! For debugging only!!! For real-world usage limit values should be, probably, >= 100 ...
WSW::API::Options::Options():
#ifdef USE_SOCI
  use_db_cache(true),
#endif
  use_legacy_replication(false),
  use_replication_heuristics(false),
  cache_ttl(300),
  /*
  rsm_modified_limit(4),
  rsm_collections_limit(4),
  rsm_messages_limit(4)
  */
  ///*
  rsm_modified_limit(100),
  rsm_collections_limit(100),
  rsm_messages_limit(100)
  //*/
  {}
//------------------------------------------------------------------------------
WSW::API::API(WSW::Drivers::XMPP::Driver* driver,
#ifdef USE_SOCI
              SOCI::Session* session,
#endif
	      const Options& opts):
  driver_(driver),
#ifdef USE_SOCI
  session_(session),
#endif
  opts_(opts)
  {
  }
//------------------------------------------------------------------------------
WSW::API::~API()
  {
  delete driver_;
#ifdef USE_SOCI
  delete session_;
#endif
  }
//------------------------------------------------------------------------------
WSW::API::Status WSW::API::executeSync_(WSW::API_details::Task* task)
  {
  task->init();

  while (!task->done())
    driver_->idle();

  WSW::API::Status res = task->result();
  delete task;

  return res;
  }
//------------------------------------------------------------------------------
