/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "stdafx.h"
#include "core.h"
#include "utils.h"

//------------------------------------------------------------------------------
using namespace WSW::Core;
//------------------------------------------------------------------------------
std::string Message::getDirectionAsString() const
  {
  switch (direction)
    {
    case FROM:
      return "from";

    case TO:
      return "to";

    case NOTE:
      return "note";

    default:
      return "";
    }
  }
//------------------------------------------------------------------------------
void Message::setDirectionFromString(const char* name)
  {
  if (!strcmp(name, "from"))
    direction = FROM;
  else if (!strcmp(name, "to"))
    direction = TO;
  else if (!strcmp(name, "note"))
    direction = NOTE;
  else
    assert(false);
  }
//------------------------------------------------------------------------------
RSM_Query::RSM_Query()
  {
  mode = NONE;
  limit = NO_LIMIT;
  }
//------------------------------------------------------------------------------
std::string RSM_Query::getModeAsString() const
  {
  switch (mode)
    {
    case BEFORE:
      return "before";

    case AFTER:
      return "after";

    case INDEX:
      return "index";

    default:
      return "";
    }
  }
//------------------------------------------------------------------------------
RSM_Result::RSM_Result(): first_index(NO_VALUE), count(NO_VALUE) {}
//------------------------------------------------------------------------------
Filter::Filter(const std::string jid): with(jid) {}
//------------------------------------------------------------------------------
CollectionLink::CollectionLink(const std::string& with_in, const WSW::DateTime::TimeType& start_in):
  with(with_in), start(start_in)
  {
  }
//------------------------------------------------------------------------------
bool CollectionLink::isValid() const
  {
  return !with.empty() && start != WSW::DateTime::TIME_INVALID;
  }
//------------------------------------------------------------------------------
bool CollectionLink::operator <(const CollectionLink& other_link) const
  {
  int v1 = with.compare(other_link.with);
  if (v1) return v1 < 0;
  return start < other_link.start;
  }
//------------------------------------------------------------------------------
CollectionInfo::CollectionInfo(): crypt(false) {}
//------------------------------------------------------------------------------
