/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef WSW_DRIVERS_XMPP_GLOOX_DRV_H
#define WSW_DRIVERS_XMPP_GLOOX_DRV_H
//------------------------------------------------------------------------------
#include "driver.h"
//------------------------------------------------------------------------------
namespace gloox { class Client; }
//------------------------------------------------------------------------------
namespace WSW
  {
  namespace Drivers
    {
    namespace XMPP
      {
      class GlooxDriver: public Driver
        {
        public:
          GlooxDriver(gloox::Client* client);

          virtual void initialize(const ReceiveStatus& func);
          virtual void retrieveCollections(const WSW::Core::Filter& filter, const WSW::Core::RSM_Query& rsm, const ReceiveCollections& func);
          virtual void retrieveMessages(const WSW::Core::CollectionLink& link, const WSW::Core::RSM_Query& rsm,
                                        const ReceiveMessages& func_msgs, const ReceiveCollection& func_coll);
          virtual void retrieveModifications(const WSW::Core::Filter& filter, const WSW::Core::RSM_Query& rsm, const ReceiveModifications& func);
          virtual void updateCollection(const WSW::Core::Collection& collection, const ReceiveStatus& func_status);

          virtual std::string getJID() const;
          virtual void idle();

        private:
          gloox::Client* client_;
        };
      }
    }
  }
//------------------------------------------------------------------------------
#endif // WSW_DRIVERS_XMPP_GLOOX_DRV_H
