/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#include "stdafx.h"
#include "task.h"
//----------------------------------------------------------------------------------
using namespace WSW::API_details;
//----------------------------------------------------------------------------------
Task::Task(WSW::Drivers::XMPP::Driver& driver, const WSW::API::Options& opts,
           const WSW::API::ReceiveStatus& func_status):
  driver_(driver),
  opts_(opts),
  func_status_(func_status),
  done_(false),
  result_(WSW::API::OK),
  fl_items_number_defined_(false)
  {
  }
//----------------------------------------------------------------------------------
void Task::cancel(WSW::API::Status res)
  {
  if (!func_status_.empty())
    {
    func_status_(res);
    delete this;
    }
  else
    {
    result_ = res;
    done_ = true;
    }
  }
//----------------------------------------------------------------------------------
void Task::finished()
  {
  if (!func_status_.empty())
    {
    func_status_(WSW::API::OK);
    delete this;
    }
  else
    {
    result_ = WSW::API::OK;
    done_ = true;
    }
  }
//----------------------------------------------------------------------------------
