/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef WSW_TASK_H
#define WSW_TASK_H

#include "api.h"
//------------------------------------------------------------------------------
namespace WSW
  {
  namespace API_details
    {
    typedef boost::function<void ()> ResumeFunction;

    class Task
      {
      public:
        Task(WSW::Drivers::XMPP::Driver& driver, const WSW::API::Options& opts,
             const WSW::API::ReceiveStatus& func_status);
        virtual ~Task() {}

        virtual void init() {}
        virtual void finished();
        virtual void cancel(WSW::API::Status res);

        bool done() const { return done_; }
        WSW::API::Status result() const { return result_; }

      protected:
        WSW::Drivers::XMPP::Driver& driver_;
        WSW::API::Options opts_;
        bool done_;
        WSW::API::Status result_;
        WSW::API::ReceiveStatus func_status_;

        bool fl_items_number_defined_;
        unsigned long items_number_;
      };
    }
  }
//------------------------------------------------------------------------------
#endif // WSW_TASK_H
