/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef WSW_TASK_INDEXED_CACHED_H
#define WSW_TASK_INDEXED_CACHED_H

#include "api.h"
#include "core.h"
#include "task_indexed.h"
#include "task_cached.h"
#include "drivers/xmpp/driver.h"

//------------------------------------------------------------------------------
namespace WSW
  {
  namespace API_details
    {
//--//--------------------------------------------------------------------------
    class TaskIndexedCached: public TaskIndexed, public TaskCached
      {
      public:
        TaskIndexedCached(WSW::Drivers::XMPP::Driver& driver, const WSW::API::Options& opts,
                          const WSW::API::ReceiveStatus& func_status, long first_index, long last_index);

        virtual void fetchCachedItems() = 0;
        virtual void outputItemFromCache() = 0;
        virtual long isCachePosValid() = 0;
        virtual CachedItem& cachedItem() = 0;
        virtual bool isDirty() = 0;
        virtual void advanceCachePos() = 0;

        virtual void init() { TaskCached::init(); }

        virtual void receiveItemsQueryFinished();
        virtual bool verifyRSM(const WSW::Core::RSM_Result& rsm, unsigned long received_size);
        virtual void fetchItems();
        virtual void finalize();
        virtual void postReceiveModifications();

        void preGetItemsNumber();
        long advanceDir(long& index);
        void setupReceiveItems();

      protected:
        long cur_item_index_;
      };
    }
  }
//------------------------------------------------------------------------------

#endif // WSW_TASK_INDEXED_CACHED_H