/*****************************************************************************
 *
 * libwsw, Copyright (C) 2007 by Alexander Tsvyashchenko
 * contact address: <ejabberd@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

//----------------------------------------------------------------------------------
template <class Items>
void WSW::API_details::TaskIndexed::receiveItems(const Items& items, const RSM_Result& rsm, Status status)
  {
  if (status == OK)
    {
    if (!fl_items_number_defined_)
      {
      if (rsm.count != RSM_Result::NO_VALUE)
        items_number_ = rsm.count;
      else
        items_number_ = 0;

      fl_items_number_defined_ = true;
      if (!calculateIndices())
        return;
      // Let the task save the number, if supported
      postReceiveItemsNumber();
      }

    if (!verifyRSM(rsm, (unsigned long)items.size()))
      return;

    unsigned long num = 0;

    if (fl_reversed_)
      for (typename Items::const_reverse_iterator it = items.rbegin(); it != items.rend(); ++it, ++num)
        receiveItemsHandleItem(*it, rsm.first_index + (unsigned long)items.size() - num - 1);
    else
      for (typename Items::const_iterator it = items.begin(); it != items.end(); ++it, ++num)
        receiveItemsHandleItem(*it, rsm.first_index + num);

    postReceiveItems(rsm, (unsigned long)items.size());
    }
  else
    cancel(WSW::API::ERROR_GET_ITEMS);
  }
//----------------------------------------------------------------------------------
template <class Items>
void WSW::API_details::TaskIndexed::receiveItemsNumber(const Items& items, const RSM_Result& rsm, Status status)
  {
  // we're interested here only in RSM
  if (status == OK)
    {
    if (!verifyRSM(rsm, (unsigned long)items.size()))
      return;
    items_number_ = rsm.count;
    fl_items_number_defined_ = true;
    postReceiveItemsNumber();
    // Pass execution further on chain.
    fetchItems();
    }
  else
    cancel(WSW::API::ERROR_GET_ITEMS_NUMBER);
  }
//----------------------------------------------------------------------------------
